//
// mbwccheck.c
//
// This file check the locale of Linux/Unix system
// Please specify locale environment before running this program
//

#include <stdio.h>
#include <stdlib.h>
#include <locale.h>

char *string = "Locale!";

void main()
{
    int i, l, length;
    char *ptr;
    char cbuf[128];
    wchar_t wcbuf[128];

    setlocale(LC_ALL, "");

    /* MB_CUR_MAX check */
    printf("MB_CUR_MAX %d\n", MB_CUR_MAX);

    length = strlen(string);
    printf("string %s, length %d\n", string, length);

    /* mbstowcs() */
    l = mbstowcs(wcbuf, string, 128);
    printf("mbstowcs() -> num %d,", l);
    for (i = 0; i < l; i++) {
	printf(" %x", wcbuf[i]);
    }
    printf("\n");

    /* wcstombs() */
    l = wcstombs(cbuf, wcbuf, 128);
    printf("wcstombs() -> length %d, %s\n", l, cbuf);

    /* mblen() check */
    for (ptr = string; *ptr; ) {
	l = mblen(ptr, length);
	mbtowc(wcbuf, ptr, length);
	printf("ptr %s, mblen %d, wchar %x\n", ptr, l, wcbuf[0]);
	if (l <= 0) {
	    break;
	}
	ptr += l;
    }
}


/*
TurboLinux µĲԽ(GBK Locale):

MB_CUR_MAX 2
string Locale!, length 17
mbstowcs() -> num 12, 6d4b 8bd5 4c 6f 63 61 6c 65 7684 8f6f 4ef6 21
wcstombs() -> length 17, Locale!
ptr Locale!, mblen 2, wchar 6d4b
ptr Locale!, mblen 2, wchar 8bd5
ptr Locale!, mblen 1, wchar 4c
ptr ocale!, mblen 1, wchar 6f
ptr cale!, mblen 1, wchar 63
ptr ale!, mblen 1, wchar 61
ptr le!, mblen 1, wchar 6c
ptr e!, mblen 1, wchar 65
ptr !, mblen 2, wchar 7684
ptr !, mblen 2, wchar 8f6f
ptr !, mblen 2, wchar 4ef6
ptr !, mblen 1, wchar 21
*/
